'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Path = Path;
exports.Query = Query;
exports.Cookie = Cookie;
exports.Header = Header;
exports.Body = Body;

var _models = require('../models');

var _browser = require('typescript-class-helpers/browser');

function metaParam(param, name, expire) {
    var defaultValue = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;

    for (var _len = arguments.length, args = Array(_len > 4 ? _len - 4 : 0), _key = 4; _key < _len; _key++) {
        args[_key - 4] = arguments[_key];
    }

    var methodName = args[1];
    var configs = _browser.CLASS.getConfig(args[0].constructor);
    var c = configs[0];
    var m = c.methods[methodName] = !c.methods[methodName] ? new _models.Models.Rest.MethodConfig() : c.methods[methodName];
    var nameKey = name ? name : param;
    var p = m.parameters[nameKey] = !m.parameters[nameKey] ? new _models.Models.Rest.ParamConfig() : m.parameters[nameKey];
    p.index = args[2];
    p.paramName = name;
    p.paramType = param;
    p.defaultType = defaultValue;
    p.expireInSeconds = expire;
}
function Path(name) {
    return function () {
        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
        }

        metaParam.apply(undefined, ['Path', name, undefined, {}].concat(args));
    };
}
function Query(name) {
    return function () {
        for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
        }

        metaParam.apply(undefined, ['Query', name, undefined, {}].concat(args));
    };
}
function Cookie(name) {
    var expireInSecond = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 3600;

    return function () {
        for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
            args[_key4] = arguments[_key4];
        }

        metaParam.apply(undefined, ['Cookie', name, expireInSecond, {}].concat(args));
    };
}
function Header(name) {
    return function () {
        for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
            args[_key5] = arguments[_key5];
        }

        metaParam.apply(undefined, ['Header', name, undefined, {}].concat(args));
    };
}
function Body(name) {
    return function () {
        for (var _len6 = arguments.length, args = Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
            args[_key6] = arguments[_key6];
        }

        metaParam.apply(undefined, ['Body', name, undefined, {}].concat(args));
    };
}