'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.BASE_CONTROLLER = undefined;
exports.Controller = Controller;

var _tslib = require('tslib');

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _decoratorsEndpointClass = require('../decorators/decorators-endpoint-class');

var _baseCrudModel = require('../crud/base-crud-model');

var _frameworkHelpers = require('./framework-helpers');

var _browser = require('typescript-class-helpers/browser');

var _browser2 = require('ng2-logger/browser');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var updatedWithCtrl = {};
var updatedStaticWithCtrl = {};
function getSing(target) {
    var res = _browser.CLASS.getSingleton(target);
    ;
    if (!res) {
        debugger;
    }
    return res;
}
function updateChain(entity, target) {
    if (!_.isFunction(entity)) {
        return;
    }
    var className = _browser.CLASS.getName(entity);
    if (updatedWithCtrl[className]) {
        console.warn('[morphi] Property \'ctrl\' already exist for ' + className);
        try {
            Object.defineProperty(entity.prototype, 'ctrl', {
                get: function get() {
                    return getSing(target);
                }
            });
        } catch (error) {}
    } else {
        updatedWithCtrl[className] = true;
        Object.defineProperty(entity.prototype, 'ctrl', {
            get: function get() {
                return getSing(target);
            }
        });
    }
    if (updatedStaticWithCtrl[className]) {
        console.warn('[morphi] Static property \'ctrl\' already exist for ' + className);
        try {
            Object.defineProperty(entity, 'ctrl', {
                get: function get() {
                    return getSing(target);
                }
            });
        } catch (error) {}
    } else {
        updatedStaticWithCtrl[className] = true;
        Object.defineProperty(entity, 'ctrl', {
            get: function get() {
                return getSing(target);
            }
        });
    }
}
function Controller(options) {
    var _ref = options || {},
        className = _ref.className,
        realtime = _ref.realtime,
        _ref$autoinit = _ref.autoinit,
        autoinit = _ref$autoinit === undefined ? false : _ref$autoinit,
        entity = _ref.entity,
        additionalEntities = _ref.additionalEntities;

    return function (target) {
        className = (0, _frameworkHelpers.classNameVlidation)(className, target);
        _browser.CLASS.NAME(className, {
            singleton: _browser2.Helpers.isBrowser ? 'autoinstance' : 'last-instance'
        })(target);
        // if (Helpers.isBrowser && _.isFunction(rep)) {
        //   target = rep;
        // }
        // debugger
        if (autoinit) {
            // console.log(`AUTOINTI!!!!! Options for ${target.name}, partnt ${target['__proto__'].name}`, options)
            (0, _decoratorsEndpointClass.__ENDPOINT)(target)(target);
        } else {
            // console.log(`Options for ${target.name}, partnt ${target['__proto__'].name}`, options)
            (0, _decoratorsEndpointClass.ENDPOINT)(options)(target);
        }
        if (_.isArray(additionalEntities)) {
            additionalEntities.forEach(function (c) {
                updateChain(c, target);
            });
        }
        if (_.isFunction(entity)) {
            updateChain(entity, target);
        }
        return target;
    };
}
var BASE_CONTROLLER = function (_BaseCRUD) {
    _inherits(BASE_CONTROLLER, _BaseCRUD);

    function BASE_CONTROLLER() {
        _classCallCheck(this, BASE_CONTROLLER);

        return _possibleConstructorReturn(this, (BASE_CONTROLLER.__proto__ || Object.getPrototypeOf(BASE_CONTROLLER)).apply(this, arguments));
    }

    return BASE_CONTROLLER;
}(_baseCrudModel.BaseCRUD);
exports.BASE_CONTROLLER = BASE_CONTROLLER = (0, _tslib.__decorate)([Controller({
    className: 'BASE_CONTROLLER',
    autoinit: true
})], BASE_CONTROLLER);
exports.BASE_CONTROLLER = BASE_CONTROLLER;