'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.BASE_ENTITY = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.Entity = Entity;

var _tslib = require('tslib');

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _browser = require('ng2-logger/browser');

var _frameworkHelpers = require('./framework-helpers');

var _browser2 = require('ng2-rest/browser');

var _realtime = require('../realtime');

var _browser3 = require('typescript-class-helpers/browser');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _browser.Log.create('Framework entity');
var updatesInProgress = {};
function getUpdateID(id, entityName, propterty, config) {
    return _.kebabCase(id) + '-' + _.kebabCase(entityName) + '-' + _.kebabCase(propterty) + '-' + (_.isObject(config) ? _.kebabCase(JSON.stringify(config)) : '');
}
var IS_RELATIME = Symbol();
var IS_RELATIME_PROPERTY = Symbol();
function getRealtimeIsRealtime(entity, property) {
    if (!_.isObject(entity[IS_RELATIME_PROPERTY])) {
        entity[IS_RELATIME_PROPERTY] = {};
    }
    return entity[IS_RELATIME_PROPERTY][property];
}
function Entity(options) {
    if (!options) {
        options = { formly: {} };
    }
    if (!options.formly) {
        options.formly = {};
    }
    var _options = options,
        defaultModelValues = _options.defaultModelValues,
        tree = _options.tree,
        mapping = _options.mapping,
        _options$additionalMa = _options.additionalMapping,
        additionalMapping = _options$additionalMa === undefined ? {} : _options$additionalMa,
        _options$uniqueKeyPro = _options.uniqueKeyProp,
        uniqueKeyProp = _options$uniqueKeyPro === undefined ? 'id' : _options$uniqueKeyPro,
        classFamily = _options.classFamily,
        className = _options.className,
        classNameInBrowser = _options.classNameInBrowser,
        _options$formly = _options.formly;
    _options$formly = _options$formly === undefined ? {} : _options$formly;
    var _options$formly$trans = _options$formly.transformFn,
        transformFn = _options$formly$trans === undefined ? undefined : _options$formly$trans,
        _options$formly$inclu = _options$formly.include,
        include = _options$formly$inclu === undefined ? undefined : _options$formly$inclu,
        _options$formly$exclu = _options$formly.exclude,
        exclude = _options$formly$exclu === undefined ? undefined : _options$formly$exclu;

    return function (target) {
        className = (0, _frameworkHelpers.classNameVlidation)(className, target);
        _browser3.CLASS.NAME(className, {
            uniqueKey: uniqueKeyProp,
            classFamily: classFamily,
            classNameInBrowser: classNameInBrowser
        })(target);
        _browser2.Mapping.DefaultModelWithMapping(defaultModelValues, _.merge(mapping, additionalMapping))(target);
    };
}

var BASE_ENTITY = exports.BASE_ENTITY = function () {
    function BASE_ENTITY() {
        _classCallCheck(this, BASE_ENTITY);
    }

    _createClass(BASE_ENTITY, [{
        key: 'isListeningToRealtimeChanges',
        value: function isListeningToRealtimeChanges(property) {
            if (_.isString(property)) {
                return !!getRealtimeIsRealtime(this, property);
            } else {
                return !!this[IS_RELATIME];
            }
        }
    }, {
        key: 'unsubscribeRealtimeUpdatesOfProperties',
        value: function unsubscribeRealtimeUpdatesOfProperties() {
            var _this = this;

            if (_.isObject(this[IS_RELATIME_PROPERTY])) {
                Object.keys(this[IS_RELATIME_PROPERTY]).forEach(function (property) {
                    _this.unsubscribeRealtimeUpdates(property);
                });
            }
        }
    }, {
        key: 'unsubscribeRealtimeUpdates',
        value: function unsubscribeRealtimeUpdates(property) {
            var _this2 = this;

            if (_.isArray(property)) {
                property.forEach(function (p) {
                    _this2.unsubscribeRealtimeUpdates(p);
                });
                return;
            }
            if (_.isString(property)) {
                _realtime.RealtimeBrowser.UnsubscribeEntityPropertyChanges(this, property);
                this[IS_RELATIME_PROPERTY][property] = void 0;
            } else {
                this[IS_RELATIME] = false;
                _realtime.RealtimeBrowser.UnsubscribeEntityChanges(this);
            }
        }
    }, {
        key: 'subscribeRealtimeUpdates',
        value: function subscribeRealtimeUpdates() {
            var _this3 = this;

            var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
            var modelDataConfig = options.modelDataConfig,
                callback = options.callback,
                afterMergeCallback = options.afterMergeCallback,
                property = options.property,
                update = options.update,
                bufforProperty = options.bufforProperty;

            var that = this;
            if (!_.isObject(this[IS_RELATIME_PROPERTY])) {
                this[IS_RELATIME_PROPERTY] = {};
            }
            var changesListener = function changesListener(entityToUpdate) {
                return function () {
                    return (0, _tslib.__awaiter)(_this3, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                        var alreadyLength, updateID, data, newData, newDataCallaback, newDataType;
                        return regeneratorRuntime.wrap(function _callee$(_context) {
                            while (1) {
                                switch (_context.prev = _context.next) {
                                    case 0:
                                        if (_.isString(bufforProperty)) {
                                            alreadyLength = 0;

                                            if (!_.isUndefined(that[bufforProperty]) && (_.isString(that[bufforProperty]) || _.isArray(that[bufforProperty]))) {
                                                alreadyLength = that[bufforProperty].length;
                                            }
                                            update = function update() {
                                                return that.ctrl.bufforedChanges(that.id, property, alreadyLength, modelDataConfig).received;
                                            };
                                        }
                                        if (_.isUndefined(update)) {
                                            update = function update() {
                                                return that.ctrl.getBy(that.id, modelDataConfig).received;
                                            };
                                        }
                                        updateID = getUpdateID(that.id, _browser3.CLASS.getNameFromObject(that), property, modelDataConfig);

                                        if (!updatesInProgress[updateID]) {
                                            _context.next = 5;
                                            break;
                                        }

                                        return _context.abrupt('return');

                                    case 5:
                                        updatesInProgress[updateID] = true;
                                        // console.log('entity should be updated !')
                                        _context.next = 8;
                                        return update();

                                    case 8:
                                        data = _context.sent;
                                        newData = data.body.json;

                                        if (_.isFunction(callback)) {
                                            newDataCallaback = callback(data);

                                            if (!_.isUndefined(newDataCallaback)) {
                                                newData = newDataCallaback;
                                            }
                                        }
                                        newDataType = _.isArray(newData) ? 'array' : _.isString(newData) ? 'string' : void 0;

                                        if (_.isString(bufforProperty) && !newDataType) {
                                            console.warn(data);
                                            console.warn('New data type is not string or array', newData);
                                        }
                                        if (_.isString(property)) {
                                            if (_.isString(bufforProperty)) {
                                                if (_.isUndefined(entityToUpdate[bufforProperty])) {
                                                    entityToUpdate[bufforProperty] = newDataType === 'array' ? [] : '';
                                                }
                                                entityToUpdate[bufforProperty] = entityToUpdate[bufforProperty].concat(newData);
                                            } else {
                                                entityToUpdate[property] = newData;
                                            }
                                        } else {
                                            mergeWhatImportant(entityToUpdate, newData);
                                            // _.merge(entityToUpdate, newData);
                                        }
                                        if (_.isFunction(afterMergeCallback)) {
                                            afterMergeCallback(entityToUpdate);
                                        }
                                        updatesInProgress[updateID] = false;

                                    case 16:
                                    case 'end':
                                        return _context.stop();
                                }
                            }
                        }, _callee, this);
                    }));
                };
            };
            if (this.isListeningToRealtimeChanges(property)) {
                console.warn('Alread listen to this ' + (_.isString(property) ? 'property: ' + property + ' of entity: ' + _browser3.CLASS.getNameFromObject(this) : 'entity: ' + _browser3.CLASS.getNameFromObject(this)) + ' ', this);
                _realtime.RealtimeBrowser.addDupicateRealtimeEntityListener(this, changesListener(this), property);
                return;
            }
            if (_.isString(property)) {
                this[IS_RELATIME_PROPERTY][property] = true;
                _realtime.RealtimeBrowser.SubscribeEntityPropertyChanges(this, property, changesListener(this));
            } else {
                this[IS_RELATIME] = true;
                _realtime.RealtimeBrowser.SubscribeEntityChanges(this, changesListener(this));
            }
            if (_.isString(bufforProperty)) {
                _realtime.RealtimeBrowser.TriggerChange(this, property);
            }
        }
    }]);

    return BASE_ENTITY;
}();

function mergeWhatImportant(dest, source) {
    if (_.isObject(source)) {
        for (var key in source) {
            if (source.hasOwnProperty(key)) {
                var element = source[key];
                if (!_.isUndefined(element)) {
                    dest[key] = source[key];
                }
            }
        }
    }
}