'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Helpers = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _json = require('json5');

var JSON5 = _interopRequireWildcard(_json);

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _browser = require('ng2-rest/browser');

var _symbols = require('./symbols');

var _browser2 = require('typescript-class-helpers/browser');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Helpers = exports.Helpers = function (_HelpersNg2Rest) {
    _inherits(Helpers, _HelpersNg2Rest);

    function Helpers() {
        _classCallCheck(this, Helpers);

        return _possibleConstructorReturn(this, (Helpers.__proto__ || Object.getPrototypeOf(Helpers)).apply(this, arguments));
    }

    _createClass(Helpers, null, [{
        key: 'isGoodPath',
        value: function isGoodPath(p) {
            return p && typeof p === 'string' && p.trim() !== '';
        }
    }, {
        key: 'isRealtimeEndpoint',
        value: function isRealtimeEndpoint(target) {
            return target && target.prototype && target.prototype[_symbols.SYMBOL.IS_ENPOINT_REALTIME];
        }
    }, {
        key: 'hasParentClassWithName',
        value: function hasParentClassWithName(target, name) {
            var targets = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

            if (!target) {
                // console.log(`false "${_.first(targets).name}" for ${targets.map(d => d.name).join(',')}`)
                return false;
            }
            targets.push(target);
            var targetProto = target['__proto__'];
            if (_.isFunction(targetProto) && _browser2.CLASS.getName(targetProto) === name) {
                // console.log(`true  "${_.first(targets).name}" for ${targets.map(d => d.name).join(',')}`)
                return true;
            }
            return this.hasParentClassWithName(targetProto, name, targets);
        }
    }, {
        key: 'runSyncOrAsync',
        value: function runSyncOrAsync(fn) {
            // let wasPromise = false;
            var promisOrValue = fn();
            if (promisOrValue instanceof Promise) {
                // wasPromise = true;
                promisOrValue = Promise.resolve(promisOrValue);
            }
            // console.log('was promis ', wasPromise)
            return promisOrValue;
        }
    }, {
        key: 'tryTransformParam',
        value: function tryTransformParam(param) {
            if (typeof param === 'string') {
                var n = Number(param);
                if (!isNaN(n)) return n;
                var bool = param.trim().toLowerCase();
                if (bool === 'true') {
                    return true;
                }
                if (bool === 'false') {
                    return false;
                }
                try {
                    var t = JSON5.parse(param);
                    return t;
                } catch (e) {
                    return param;
                }
            }
            return param;
        }
    }, {
        key: 'getExpressPath',
        value: function getExpressPath(c, pathOrClassConfig) {
            if (typeof pathOrClassConfig === 'string') return ('' + c.calculatedPath + pathOrClassConfig).replace(/\/$/, '');
            return ('' + c.calculatedPath + pathOrClassConfig.path).replace(/\/$/, '');
        }
    }, {
        key: 'defaultType',
        value: function defaultType(value) {
            if (typeof value === 'string') return '';
            if (typeof value === 'boolean') return false;
            if (Array.isArray(value)) return {};
            if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') return {};
        }
    }, {
        key: 'getSingleton',
        value: function getSingleton(target) {
            var configs = _browser2.CLASS.getConfig(target);
            return Array.isArray(configs) && configs.length >= 1 ? configs[0].singleton : undefined;
        }
    }, {
        key: 'getSingletons',
        value: function getSingletons(target) {
            var configs = _browser2.CLASS.getConfig(target);
            return configs.map(function (c) {
                return c.singleton;
            });
        }
    }, {
        key: 'parseJSONwithStringJSONs',
        value: function parseJSONwithStringJSONs(object) {
            var _this2 = this;

            var waring = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            // console.log('checking object', object)
            if (!_.isObject(object)) {
                if (waring) {
                    console.error('\n        parseJSONwithStringJSONs(...)\n        Parameter should be a object, but is ' + (typeof object === 'undefined' ? 'undefined' : _typeof(object)) + '\n        ', object);
                }
                return object;
            }
            var res = _.cloneDeep(object);
            Object.keys(res).forEach(function (key) {
                var isJson = false;
                try {
                    var possibleJSON = JSON.parse(res[key]);
                    res[key] = possibleJSON;
                    isJson = true;
                } catch (e) {
                    isJson = false;
                }
                // console.log(`key ${key} is json `, isJson)
                if (isJson) {
                    res[key] = _this2.parseJSONwithStringJSONs(res[key], false);
                }
            });
            return res;
        }
    }]);

    return Helpers;
}(_browser.Helpers);