'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RealtimeBrowser = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _socket = require('socket.io-client');

var io = _interopRequireWildcard(_socket);

var _globalConfig = require('../global-config');

var _symbols = require('../symbols');

var _browser = require('ng2-logger/browser');

var _browser2 = require('typescript-class-helpers/browser');

var _realtimeHelper = require('./realtime-helper');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _browser.Log.create('RealtimeBrowser', _browser.Level.__NOTHING);

var RealtimeBrowser = exports.RealtimeBrowser = function () {
    function RealtimeBrowser() {
        _classCallCheck(this, RealtimeBrowser);
    }

    _createClass(RealtimeBrowser, null, [{
        key: 'init',
        value: function init() {
            if (RealtimeBrowser.connected) {
                log.warn('BROWSER ALREADY CONNECTED!');
                return;
            }
            RealtimeBrowser.connected = true;
            // RealtimeHelper.pathFor(SYMBOL.REALTIME.NAMESPACE).hostname
            var nspPath = {
                global: _realtimeHelper.RealtimeHelper.pathFor(),
                realtime: _realtimeHelper.RealtimeHelper.pathFor(_symbols.SYMBOL.REALTIME.NAMESPACE)
            };
            log.i('NAMESPACE GLOBAL', nspPath.global.href);
            log.i('NAMESPACE REALTIME', nspPath.realtime.href);
            var global = io(nspPath.global.origin, {
                path: nspPath.global.pathname
            });
            _globalConfig.Global.vars.socketNamespace.FE = global;
            global.on('connect', function () {
                log.i('conented to GLOBAL namespace ' + global.nsp);
            });
            log.i('IT SHOULD CONNECT TO GLOBAL');
            var realtime = io(nspPath.realtime.origin, {
                path: nspPath.realtime.pathname
            });
            _globalConfig.Global.vars.socketNamespace.FE_REALTIME = realtime;
            realtime.on('connect', function () {
                log.i('conented to REALTIME namespace ' + realtime.nsp);
            });
            log.i('IT SHOULD CONNECT TO REALTIME');
        }
    }, {
        key: 'TriggerChange',
        value: function TriggerChange(entity, property) {
            var _this = this;

            var constructFn = _browser2.CLASS.getFromObject(entity);
            if (!constructFn) {
                log.er('Activate: Cannot retrive Class function from object', entity);
                return;
            }
            var className = _browser2.CLASS.getName(constructFn);
            var id = entity.id;

            var unsub = function unsub() {
                if (_.isString(property)) {
                    _this.UnsubscribeEntityPropertyChanges(entity, property);
                } else {
                    _this.UnsubscribeEntityChanges(entity);
                }
            };
            if (_.isString(property)) {
                var propertyInEntityKey = propertyInEntityKeyFn(entity, property);
                var arr = RealtimeBrowser.realtimeEntityPropertyListener[className][propertyInEntityKey];
                if (_.isArray(arr)) {
                    arr.forEach(function (changeListenerFromArray) {
                        changeListenerFromArray(unsub);
                    });
                }
            } else {
                var _arr = RealtimeBrowser.realtimeEntityListener[className][entity.id];
                if (_.isArray(_arr)) {
                    _arr.forEach(function (changeListenerFromArray) {
                        changeListenerFromArray(unsub);
                    });
                }
            }
        }
    }, {
        key: '__SubscribeEntityChanges',
        value: function __SubscribeEntityChanges(entity, changesListener, property) {
            var _this2 = this;

            var id = entity.id;

            var propertyInEntityKey = propertyInEntityKeyFn(entity, property);
            if (!_.isNumber(id)) {
                console.error(entity);
                throw '[Morphi.Realtime.Browser.Subscribe] bad id = "' + id + '" for entity.';
            }
            var constructFn = _browser2.CLASS.getFromObject(entity);
            if (!constructFn) {
                log.er('Activate: Cannot retrive Class function from object', entity);
                return;
            }
            var className = _browser2.CLASS.getName(constructFn);
            this.checkObjects(className, entity, property, changesListener);
            var roomName = _.isString(property) ? _symbols.SYMBOL.REALTIME.ROOM_NAME.UPDATE_ENTITY_PROPERTY(className, property, entity.id) : _symbols.SYMBOL.REALTIME.ROOM_NAME.UPDATE_ENTITY(className, entity.id);
            var realtime = _globalConfig.Global.vars.socketNamespace.FE_REALTIME;
            var ngZone = _globalConfig.Global.vars.ngZone;
            // realtime.on('connect', () => {
            //   console.log(`conented to namespace ${realtime.nsp && realtime.nsp.name}`)
            if (_.isString(property)) {
                realtime.emit(_symbols.SYMBOL.REALTIME.ROOM.SUBSCRIBE.ENTITY_PROPERTY_UPDATE_EVENTS, roomName);
                log.i('SUBSCRIBE TO ' + _symbols.SYMBOL.REALTIME.EVENT.ENTITY_PROPTERY_UPDATE_BY_ID(className, property, entity.id));
            } else {
                realtime.emit(_symbols.SYMBOL.REALTIME.ROOM.SUBSCRIBE.ENTITY_UPDATE_EVENTS, roomName);
                log.i('SUBSCRIBE TO ' + _symbols.SYMBOL.REALTIME.EVENT.ENTITY_UPDATE_BY_ID(className, entity.id));
            }
            var callback = function callback(data) {
                var cb = _.debounce(function () {
                    if (_.isFunction(changesListener)) {
                        var self = _this2;
                        var unsub = function unsub() {
                            if (_.isString(property)) {
                                _this2.UnsubscribeEntityPropertyChanges(entity, property);
                            } else {
                                _this2.UnsubscribeEntityChanges(entity);
                            }
                        };
                        if (_.isString(property)) {
                            var arr = RealtimeBrowser.realtimeEntityPropertyListener[className][propertyInEntityKey];
                            if (_.isArray(arr)) {
                                arr.forEach(function (changeListenerFromArray) {
                                    changeListenerFromArray(unsub);
                                });
                            }
                        } else {
                            var _arr2 = RealtimeBrowser.realtimeEntityListener[className][entity.id];
                            if (_.isArray(_arr2)) {
                                _arr2.forEach(function (changeListenerFromArray) {
                                    changeListenerFromArray(unsub);
                                });
                            }
                        }
                    } else {
                        log.er('Please define changedEntity');
                    }
                }, 1000);
                log.i('data from socket without preparation (ngzone,rjxjs,transform)', data);
                if (ngZone) {
                    ngZone.run(function () {
                        log.d('next from ngzone');
                        cb();
                    });
                } else {
                    log.d('next without ngzone');
                    cb();
                }
                // if (ApplicationRef) {
                //   log.i('tick application ')
                //   ApplicationRef.tick()
                // }
            };
            var sub = void 0;
            if (_.isString(property)) {
                sub = realtime.on(_symbols.SYMBOL.REALTIME.EVENT.ENTITY_PROPTERY_UPDATE_BY_ID(className, property, entity.id), callback);
                RealtimeBrowser.realtimeEntityPropertySockets[className][propertyInEntityKey] = sub;
                RealtimeBrowser.realtimeEntityPropertyListener[className][propertyInEntityKey].push(changesListener);
            } else {
                sub = realtime.on(_symbols.SYMBOL.REALTIME.EVENT.ENTITY_UPDATE_BY_ID(className, entity.id), callback);
                RealtimeBrowser.realtimeEntitySockets[className][entity.id] = sub;
                RealtimeBrowser.realtimeEntityListener[className][entity.id].push(changesListener);
            }
        }
    }, {
        key: 'addDupicateRealtimeEntityListener',
        value: function addDupicateRealtimeEntityListener(entity, changesListener, property) {
            var className = _browser2.CLASS.getNameFromObject(entity);
            if (_.isUndefined(RealtimeBrowser.realtimeEntityPropertyListener[className])) {
                RealtimeBrowser.realtimeEntityPropertyListener[className] = {};
            }
            if (_.isString(property)) {
                var propertyInEntityKey = propertyInEntityKeyFn(entity, property);
                RealtimeBrowser.realtimeEntityPropertyListener[className][propertyInEntityKey].push(changesListener);
            } else {
                RealtimeBrowser.realtimeEntityListener[className][entity.id].push(changesListener);
            }
        }
    }, {
        key: 'SubscribeEntityChanges',
        value: function SubscribeEntityChanges(entity, changesListener) {
            return RealtimeBrowser.__SubscribeEntityChanges(entity, changesListener);
        }
    }, {
        key: 'SubscribeEntityPropertyChanges',
        value: function SubscribeEntityPropertyChanges(entity, property, changesListener) {
            return RealtimeBrowser.__SubscribeEntityChanges(entity, changesListener, property);
        }
    }, {
        key: 'checkObjects',
        value: function checkObjects(className, entity, property, changesListener) {
            if (_.isString(property)) {
                if (_.isUndefined(RealtimeBrowser.realtimeEntityPropertySockets[className])) {
                    RealtimeBrowser.realtimeEntityPropertySockets[className] = {};
                }
                if (_.isUndefined(RealtimeBrowser.realtimeEntityPropertyListener[className])) {
                    RealtimeBrowser.realtimeEntityPropertyListener[className] = {};
                }
                var propertyInEntityKey = propertyInEntityKeyFn(entity, property);
                if (!_.isArray(RealtimeBrowser.realtimeEntityPropertyListener[className][propertyInEntityKey])) {
                    RealtimeBrowser.realtimeEntityPropertyListener[className][propertyInEntityKey] = [];
                }
                if (_.isObject(RealtimeBrowser.realtimeEntityPropertyListener[className][propertyInEntityKey])) {
                    log.w('alread listen to this object property: ' + property + ' realtime events', entity);
                    if (!RealtimeBrowser.realtimeEntityPropertyListener[className][propertyInEntityKey].includes(changesListener)) {
                        log.d('new change listener added, property: ' + property, entity);
                        RealtimeBrowser.realtimeEntityPropertyListener[className][propertyInEntityKey].push(changesListener);
                    } else {
                        log.d('change listener already exist, property: ' + property, entity);
                    }
                    return false;
                }
            } else {
                if (_.isUndefined(RealtimeBrowser.realtimeEntitySockets[className])) {
                    RealtimeBrowser.realtimeEntitySockets[className] = {};
                }
                if (_.isUndefined(RealtimeBrowser.realtimeEntityListener[className])) {
                    RealtimeBrowser.realtimeEntityListener[className] = {};
                }
                if (!_.isArray(RealtimeBrowser.realtimeEntityListener[className][entity.id])) {
                    RealtimeBrowser.realtimeEntityListener[className][entity.id] = [];
                }
                if (_.isObject(RealtimeBrowser.realtimeEntitySockets[className][entity.id])) {
                    log.w('alread listen to this object realtime events', entity);
                    if (!RealtimeBrowser.realtimeEntityListener[className][entity.id].includes(changesListener)) {
                        log.d('new change listener added', entity);
                        RealtimeBrowser.realtimeEntityListener[className][entity.id].push(changesListener);
                    } else {
                        log.d('change listener already exist', entity);
                    }
                    return false;
                }
            }
            return true;
        }
    }, {
        key: '__UnsubscribeEntityChanges',
        value: function __UnsubscribeEntityChanges(entity, property) {
            var _this3 = this;

            var includePropertyChanges = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
            var classFN = arguments[3];

            if (includePropertyChanges) {
                _browser2.CLASS.describeProperites(_browser2.CLASS.getFromObject(entity)).forEach(function (property) {
                    _this3.UnsubscribeEntityPropertyChanges(entity, property);
                });
            }
            var id = entity.id;

            if (!_.isNumber(id)) {
                console.error(entity);
                throw '[Morphi.Realtime.Browser.Unsubscribe] bad id = "' + id + '" for entity.';
            }
            var constructFn = _.isFunction(classFN) ? classFN : _browser2.CLASS.getFromObject(entity);
            if (!constructFn) {
                log.er('Deactivate: Cannot retrive Class function from object', entity);
                return;
            }
            var className = _browser2.CLASS.getName(constructFn);
            var realtime = _globalConfig.Global.vars.socketNamespace.FE_REALTIME;
            var roomName = _.isString(property) ? _symbols.SYMBOL.REALTIME.ROOM_NAME.UPDATE_ENTITY_PROPERTY(className, property, entity.id) : _symbols.SYMBOL.REALTIME.ROOM_NAME.UPDATE_ENTITY(className, entity.id);
            var sub = void 0;
            if (_.isString(property)) {
                var propertyInEntityKey = propertyInEntityKeyFn(entity, property);
                sub = RealtimeBrowser.realtimeEntityPropertySockets[className] && RealtimeBrowser.realtimeEntityPropertySockets[className][propertyInEntityKey];
            } else {
                sub = RealtimeBrowser.realtimeEntitySockets[className] && RealtimeBrowser.realtimeEntitySockets[className][entity.id];
            }
            if (sub) {
                sub.removeAllListeners();
                if (_.isString(property)) {
                    delete RealtimeBrowser.realtimeEntityPropertyListener[className][propertyInEntityKey];
                } else {
                    delete RealtimeBrowser.realtimeEntityListener[className][entity.id];
                }
                console.info('Unsubscribe OK from entit: ' + className + ' - ' + (propertyInEntityKey ? propertyInEntityKey : entity.id));
            } else {
                console.info('Unsubscribe not found from entity: ' + className + ' - ' + (propertyInEntityKey ? propertyInEntityKey : entity.id));
            }
            if (_.isString(property)) {
                realtime.emit(_symbols.SYMBOL.REALTIME.ROOM.UNSUBSCRIBE.ENTITY_PROPERTY_UPDATE_EVENTS, roomName);
            } else {
                realtime.emit(_symbols.SYMBOL.REALTIME.ROOM.UNSUBSCRIBE.ENTITY_UPDATE_EVENTS, roomName);
            }
        }
    }, {
        key: 'UnsubscribeEverything',
        value: function UnsubscribeEverything() {
            var _this4 = this;

            Object.keys(this.realtimeEntitySockets).forEach(function (className) {
                Object.keys(_this4.realtimeEntitySockets[className]).forEach(function (entityId) {
                    _this4.__UnsubscribeEntityChanges({ id: entityId }, undefined, true, _browser2.CLASS.getBy(className));
                });
            });
        }
    }, {
        key: 'UnsubscribeEntityChanges',
        value: function UnsubscribeEntityChanges(entity) {
            var includePropertyChanges = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            return RealtimeBrowser.__UnsubscribeEntityChanges(entity, undefined, includePropertyChanges);
        }
    }, {
        key: 'UnsubscribeEntityPropertyChanges',
        value: function UnsubscribeEntityPropertyChanges(entity, property) {
            return RealtimeBrowser.__UnsubscribeEntityChanges(entity, property);
        }
    }]);

    return RealtimeBrowser;
}();

RealtimeBrowser.connected = false;
RealtimeBrowser.realtimeEntityListener = {};
RealtimeBrowser.realtimeEntityPropertyListener = {};
RealtimeBrowser.realtimeEntitySockets = {};
RealtimeBrowser.realtimeEntityPropertySockets = {};
function propertyInEntityKeyFn(entity, property) {
    return '' + entity.id + property;
}