export { ModelDataConfig, MDC } from './crud/model-data-config';
export { Helpers } from './helpers';
export { Models } from './models';
export { RepeatTypeComponent } from './crud/formly-repeat-component';
export { FormlyHorizontalWrapper } from './crud/formly-group-wrapper-component';
import * as crudMorph from './crud';
import * as decoratorsMorphi from './decorators';
import * as framework from './framework';
import * as realtime from './realtime';
import * as global from './global-config';
import * as models from './models';
import * as sym from './symbols';
import * as isom from './isomorphic-replacements';
export declare namespace Morphi {
    const IsNode: boolean;
    const IsBrowser: boolean;
    const Config: global.Global;
    /**
     * Header name for model data config
     */
    const MDC_KEY: string;
    const Platform: string;
    const Providers: Function[];
    export import Response = models.Models.Response;
    export import Controller = framework.Controller;
    export import Entity = framework.Entity;
    export import init = framework.start;
    export import SYMBOL = sym.SYMBOL;
    namespace Realtime {
        namespace Browser {
            export import Class = realtime.RealtimeBrowser;
            const SubscribeEntityChanges: typeof Class.SubscribeEntityChanges;
            const SubscribeEntityPropertyChanges: typeof Class.SubscribeEntityPropertyChanges;
            const UnsubscribeEverything: typeof Class.UnsubscribeEverything;
            const UnsubscribeEntityChanges: typeof Class.UnsubscribeEntityChanges;
            const UnsubscribeEntityPropertyChanges: typeof Class.UnsubscribeEntityPropertyChanges;
        }
    }
    namespace CRUD {
        export import ModelDataConfig = crudMorph.ModelDataConfig;
        export import Base = crudMorph.BaseCRUD;
    }
    namespace Formly {
        export import getFrom = crudMorph.getFromlyConfigFor;
        export import RegisterComponentForEntity = crudMorph.RegisterComponentTypeForEntity;
    }
    namespace Base {
        export import Controller = framework.BASE_CONTROLLER;
        export import Entity = framework.BASE_ENTITY;
    }
    namespace Http {
        export import GET = decoratorsMorphi.GET;
        export import POST = decoratorsMorphi.POST;
        export import PUT = decoratorsMorphi.PUT;
        export import DELETE = decoratorsMorphi.DELETE;
        export import PATCH = decoratorsMorphi.PATCH;
        export import HEAD = decoratorsMorphi.HEAD;
        namespace Param {
            export import Query = decoratorsMorphi.Query;
            export import Path = decoratorsMorphi.Path;
            export import Body = decoratorsMorphi.Body;
            export import Cookie = decoratorsMorphi.Cookie;
            export import Header = decoratorsMorphi.Header;
        }
        namespace Resopnse {
            export import Success = models.Models.Rest.HttpResponse;
            export import Error = models.Models.Rest.HttpResponseError;
        }
    }
    namespace Auth {
    }
    namespace Orm {
        export import Repository = isom.TypeormRepository;
    }
}
