"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
//#region @backend
var path = require("path");
var fse = require("fs-extra");
var fs = require("fs");
var os = require("os");
var chalk_1 = require("chalk");
var child = require("child_process");
var commandExistsSync = require('command-exists').sync;
function copyExampleTo(folder, exampleType) {
    var options = {
        overwrite: true,
        recursive: true,
        errorOnExist: true,
        filter: function (src) {
            return !/.*node_modules.*/g.test(src);
        }
    };
    var example = {
        dist: path.join(__dirname, '..', '..', exampleType),
        bundle: path.join(__dirname, '..', exampleType)
    };
    var destinationPath = path.join(process.cwd(), folder);
    var distMode = fs.existsSync(example.dist);
    var sourcePath = distMode ? example.dist : example.bundle;
    if (os.platform() === 'win32') {
        sourcePath = path.win32.normalize(sourcePath);
        destinationPath = path.win32.normalize(destinationPath);
    }
    console.log(chalk_1.default.green("Creating example structure... please wait."));
    if (distMode) {
        fse.copySync(sourcePath, destinationPath, options);
    }
    else {
        child.execSync("cpr \"" + sourcePath + "\" \"" + destinationPath + "\" --owerwrite");
    }
    // console.log(chalk.green(`Morphi example structure created sucessfully, installing npm...`));
    // child.execSync('npm i', { cwd: destinationPath })
    console.log(chalk_1.default.green('Done.'));
    if (commandExistsSync('code')) {
        child.execSync('code .', { cwd: destinationPath });
    }
}
exports.copyExampleTo = copyExampleTo;
//#endregion
//# sourceMappingURL=new.js.map