'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.MDC = exports.ModelDataConfig = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _helpers = require('../helpers');

var _browser = require('ng2-rest/browser');

var _browser2 = require('typescript-class-helpers/browser');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ModelDataConfig_1;
// import { Subject } from 'rxjs/Subject'; // TODO use rxjs to detec change
// import { Observable } from 'rxjs/Observable';

var MAX_DATA_LENGTH_SENT_TO_CLIENT = 10000;
var ModelDataConfig = ModelDataConfig_1 = function () {
    function ModelDataConfig(config) {
        _classCallCheck(this, ModelDataConfig);

        if (config && _.isString(config['config'])) {
            // console.log('from nested config')
            this.config = _helpers.Helpers.parseJSONwithStringJSONs(JSON.parse(config['config']));
        } else if (config) {
            // console.log('from normal interface config')
            this.config = _helpers.Helpers.parseJSONwithStringJSONs(config);
        } else {
            // console.log('from default config')
            this.config = this.defaultConfig;
        }
        if (_.isUndefined(this.config.pagination)) {
            this.config.pagination = this.defaultConfig.pagination;
        }
        if (_.isUndefined(this.config.sorting)) {
            this.config.sorting = this.defaultConfig.sorting;
        }
        if (_.isUndefined(this.config.joins)) {
            this.config.joins = this.defaultConfig.joins;
        }
        if (_.isUndefined(this.config.where)) {
            this.config.where = this.defaultConfig.where;
        }
        if (_helpers.Helpers.isNode) {
            if (_.isUndefined(this.config.include)) {
                this.config.include = [];
            }
            if (_.isUndefined(this.config.exclude)) {
                this.config.exclude = [];
            }
        }
        // console.log('config', config)
    }

    _createClass(ModelDataConfig, [{
        key: 'toString',
        value: function toString() {
            return JSON.stringify(this);
        }
    }, {
        key: 'defaultConfig',
        get: function get() {
            return {
                joins: [],
                where: [],
                sorting: {},
                pagination: {
                    pageNumber: 1,
                    rowsDisplayed: MAX_DATA_LENGTH_SENT_TO_CLIENT,
                    totalElements: MAX_DATA_LENGTH_SENT_TO_CLIENT
                }
            };
        }
    }, {
        key: 'set',
        get: function get() {
            var self = this;
            return {
                include: function include(entity) {
                    if (_.isArray(entity)) {
                        entity.forEach(function (e) {
                            self.set.include(e);
                        });
                        return;
                    }
                    if (_.isArray(self.config.include) && self.config.include.length > 0) {
                        if (_.isObject(entity)) {
                            Object.keys(entity).forEach(function (key) {
                                if (!self.config.include.includes(key)) {
                                    _.set(entity, key, void 0);
                                }
                            });
                        }
                    }
                },
                exclude: function exclude(entity) {
                    if (_.isArray(entity)) {
                        entity.forEach(function (e) {
                            self.set.exclude(e);
                        });
                        return;
                    }
                    if (_.isArray(self.config.exclude) && self.config.exclude.length > 0) {
                        self.config.exclude.forEach(function (ex) {
                            _.set(entity, ex, void 0);
                        });
                    }
                },
                where: function where(command) {
                    if (command === undefined) {
                        return;
                    }

                    var _command$split$map = command.split('=').map(function (c) {
                        return c.trim();
                    }),
                        _command$split$map2 = _slicedToArray(_command$split$map, 2),
                        wherePath = _command$split$map2[0],
                        value = _command$split$map2[1];

                    var founded = self.config.where.find(function (c) {
                        var _c$split$map = c.split('=').map(function (c) {
                            return c.trim();
                        }),
                            _c$split$map2 = _slicedToArray(_c$split$map, 1),
                            wherePath2 = _c$split$map2[0];

                        return wherePath === wherePath2;
                    });
                    if (command.trim().endsWith('=') || value && value.trim() === 'undefined') {
                        self.config.where = self.config.where.filter(function (c) {
                            var _c$split$map3 = c.split('=').map(function (c) {
                                return c.trim();
                            }),
                                _c$split$map4 = _slicedToArray(_c$split$map3, 1),
                                wherePath2 = _c$split$map4[0];

                            return wherePath !== wherePath2;
                        });
                        return;
                    }
                    if (founded) {
                        var index = self.config.where.indexOf(founded);
                        self.config.where[index] = command;
                    } else {
                        self.config.where.push(command);
                    }
                    // self._modelConfigChanged.next(self);
                },
                joins: function joins(command) {
                    if (command === undefined) {
                        return;
                    }
                    var founded = self.config.joins.find(function (j) {
                        return command.trim() === j.trim();
                    });
                    if (founded) {
                        var index = self.config.joins.indexOf(founded);
                        self.config.joins[index] = command;
                    } else {
                        self.config.joins.push(command);
                    }
                    // self._modelConfigChanged.next(self);
                },

                get pagination() {
                    return {
                        totalElement: function totalElement(value) {
                            self.config.pagination.totalElements = value;
                            // self._modelConfigChanged.next(self);
                        },
                        pageNumber: function pageNumber(value) {
                            self.config.pagination.pageNumber = value;
                            // self._modelConfigChanged.next(self);
                        },
                        rowDisplayed: function rowDisplayed(value) {
                            self.config.pagination.rowsDisplayed = value;
                            // self._modelConfigChanged.next(self);
                        }
                    };
                }
            };
        }
    }, {
        key: 'get',
        get: function get() {
            var self = this;
            return {
                get pagination() {
                    return {
                        get totalElements() {
                            return Number(_.get(self, "config.pagination.totalElements"));
                        },
                        get pageNumber() {
                            return Number(_.get(self, "config.pagination.pageNumber"));
                        },
                        get rowsDisplayed() {
                            return Number(_.get(self, "config.pagination.rowsDisplayed"));
                        }
                    };
                }
            };
        }
    }], [{
        key: 'create',
        value: function create(config) {
            return new ModelDataConfig_1(config);
        }
    }]);

    return ModelDataConfig;
}();
exports.ModelDataConfig = ModelDataConfig = ModelDataConfig_1 = (0, _tslib.__decorate)([_browser2.CLASS.NAME('ModelDataConfig'), _browser.Mapping.DefaultModelWithMapping({}), (0, _tslib.__metadata)("design:paramtypes", [Object])], ModelDataConfig);
exports.ModelDataConfig = ModelDataConfig;

var MDC = exports.MDC = function (_ModelDataConfig) {
    _inherits(MDC, _ModelDataConfig);

    function MDC() {
        _classCallCheck(this, MDC);

        return _possibleConstructorReturn(this, (MDC.__proto__ || Object.getPrototypeOf(MDC)).apply(this, arguments));
    }

    return MDC;
}(ModelDataConfig);