'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.findTypeForEntity = findTypeForEntity;
exports.typeFromEntity = typeFromEntity;
exports.typeFromName = typeFromName;
exports.RegisterComponentTypeForEntity = RegisterComponentTypeForEntity;
exports.RegisterComponentType = RegisterComponentType;
exports.getRegisteredComponents = getRegisteredComponents;

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _browser = require('typescript-class-helpers/browser');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function findTypeForEntity(entity) {
    var isArray = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    if (!_.isArray(RegisterComponentType.prototype.types)) {
        RegisterComponentType.prototype.types = [];
    }
    return getRegisteredComponents().find(function (c) {
        return c.entity === entity && c.isArray === isArray;
    });
}
function typeFromEntity(component, entity) {
    var isArray = _.isArray(entity);
    if (isArray) {
        entity = _.first(entity);
    }
    var name = _browser.CLASS.getName(component);
    var res = { name: name, component: component, entity: entity, isArray: isArray };
    // console.log(res);
    return res;
}
function typeFromName(component, name) {
    var res = { name: name, component: component };
    return res;
}
function RegisterComponentTypeForEntity(entity) {
    if (!_.isArray(RegisterComponentType.prototype.types)) {
        RegisterComponentType.prototype.types = [];
    }
    return function (target, propertyKey, descriptor) {
        RegisterComponentType.prototype.types.push(typeFromEntity(target, entity));
    };
}
function RegisterComponentType(className) {
    for (var _len = arguments.length, optionslNames = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        optionslNames[_key - 1] = arguments[_key];
    }

    if (!_.isArray(RegisterComponentType.prototype.types)) {
        RegisterComponentType.prototype.types = [];
    }
    return function (target, propertyKey, descriptor) {
        _browser.CLASS.NAME(className)(target);
        RegisterComponentType.prototype.types.push(typeFromEntity(target));
        optionslNames.forEach(function (name) {
            RegisterComponentType.prototype.types.push(typeFromName(target, name));
        });
    };
}
// RegisterComponentType.prototype.types = []
function getRegisteredComponents() {
    var registered = RegisterComponentType.prototype.types;
    if (!Array.isArray(registered)) {
        return [];
    }
    // console.log(registered)
    return registered;
}