'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Connection = exports.CLASS = undefined;

var _browser = require('typescript-class-helpers/browser');

Object.defineProperty(exports, 'CLASS', {
    enumerable: true,
    get: function get() {
        return _browser.CLASS;
    }
});

var _browser2 = require('typeorm/browser');

Object.defineProperty(exports, 'Connection', {
    enumerable: true,
    get: function get() {
        return _browser2.Connection;
    }
});
exports.__ENDPOINT = __ENDPOINT;
exports.ENDPOINT = ENDPOINT;

var _initMethod = require('../init-method');

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _globalConfig = require('../global-config');

var _symbols = require('../symbols');

var _helpers = require('../helpers');

var _activateBaseCrud = require('../crud/activate-base-crud');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function __ENDPOINT(baseEntity) {
    if (baseEntity) _globalConfig.Global.vars.__core_controllers.push(baseEntity);
    return ENDPOINT();
}
function ENDPOINT(options) {
    return function (target) {
        var _ref = options ? options : {},
            path = _ref.path,
            auth = _ref.auth,
            _ref$realtime = _ref.realtime,
            realtime = _ref$realtime === undefined ? false : _ref$realtime,
            entity = _ref.entity,
            additionalEntities = _ref.additionalEntities;

        target.prototype[_symbols.SYMBOL.IS_ENPOINT_REALTIME] = realtime;
        var initFN = function (target, path, auth) {
            return function () {
                // debugger
                // console.log(`INITING ${target.name} , parent ${target['__proto__'].name} `)
                (0, _activateBaseCrud.activateBaseCrud)(target, entity, additionalEntities);
                //#region  access decorator config
                var configs = _browser.CLASS.getConfig(target);
                // console.log(`Class config for ${CLASS.getName(target)}`, configs)
                var classConfig = configs[0];
                classConfig.path = path;
                var parentscalculatedPath = _.slice(configs, 1).reverse().map(function (bc) {
                    if (_helpers.Helpers.isGoodPath(bc.path)) {
                        return bc.path;
                    }
                    return _browser.CLASS.getName(bc.classReference);
                }).join('/');
                if (_helpers.Helpers.isGoodPath(path)) {
                    classConfig.calculatedPath = path;
                } else {
                    classConfig.calculatedPath = ('/' + parentscalculatedPath + '/' + _browser.CLASS.getName(target)).replace(/\/\//g, '/');
                }
                // console.log(`${classConfig.calculatedPath}, target ${target.name}`)
                var checkAuthFn = auth && typeof auth === 'function';
                _.slice(configs, 1).forEach(function (bc) {
                    var alreadyIs = classConfig.methods;
                    var toMerge = _.cloneDeep(bc.methods);
                    for (var key in toMerge) {
                        if (toMerge.hasOwnProperty(key) && !alreadyIs[key]) {
                            var element = toMerge[key];
                            alreadyIs[key] = element;
                        }
                    }
                });
                //#endregion
                Object.keys(classConfig.methods).forEach(function (methodName) {
                    var methodConfig = classConfig.methods[methodName];
                    var type = methodConfig.type;
                    var expressPath = _helpers.Helpers.getExpressPath(classConfig, methodConfig);
                    // console.log('initfn expressPath', expressPath)
                    if (_helpers.Helpers.isNode) {}
                    if (_helpers.Helpers.isBrowser) {
                        (0, _initMethod.initMethodBrowser)(target, type, methodConfig, expressPath);
                    }
                });
            };
        }(target, path, auth);
        target.prototype[_symbols.SYMBOL.CLASS_DECORATOR_CONTEXT] = { initFN: initFN, target: target };
        _globalConfig.Global.vars.initFunc.push({ initFN: initFN, target: target });
    };
}
// TODO allowed hosts in progress