'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.GET = GET;
exports.HEAD = HEAD;
exports.POST = POST;
exports.PUT = PUT;
exports.PATCH = PATCH;
exports.DELETE = DELETE;

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _models = require('../models');

var _browser = require('typescript-class-helpers/browser');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function metaReq(method, path, target, propertyKey, descriptor) {
    var realtimeUpdate = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;

    var configs = _browser.CLASS.getConfig(target.constructor);
    var c = configs[0];
    var m = c.methods[propertyKey] = !c.methods[propertyKey] ? new _models.Models.Rest.MethodConfig() : c.methods[propertyKey];
    m.methodName = propertyKey;
    m.type = method;
    // debugger
    if (!path) {
        var paramsPathConcatedPath = '';
        for (var key in m.parameters) {
            if (m.parameters.hasOwnProperty(key)) {
                var element = m.parameters[key];
                if (element.paramType === 'Path' && _.isString(element.paramName) && element.paramName.trim().length > 0) {
                    paramsPathConcatedPath += '/' + element.paramName + '/:' + element.paramName;
                }
            }
        }
        m.path = '/' + propertyKey + paramsPathConcatedPath;
        // console.log(`Authogenerated path: `, m.path)
    } else {
        m.path = path;
    }
    m.descriptor = descriptor;
    m.realtimeUpdate = realtimeUpdate;
}
function GET(path) {
    var realtimeUpdate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    return function (target, propertyKey, descriptor) {
        metaReq('get', path, target, propertyKey, descriptor, realtimeUpdate);
    };
}
function HEAD(path) {
    var realtimeUpdate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    return function (target, propertyKey, descriptor) {
        metaReq('head', path, target, propertyKey, descriptor, realtimeUpdate);
    };
}
function POST(path) {
    return function (target, propertyKey, descriptor) {
        metaReq('post', path, target, propertyKey, descriptor);
    };
}
function PUT(path) {
    return function (target, propertyKey, descriptor) {
        metaReq('put', path, target, propertyKey, descriptor);
    };
}
function PATCH(path) {
    return function (target, propertyKey, descriptor) {
        metaReq('patch', path, target, propertyKey, descriptor);
    };
}
function DELETE(path) {
    return function (target, propertyKey, descriptor) {
        metaReq('delete', path, target, propertyKey, descriptor);
    };
}