'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.classNameVlidation = classNameVlidation;

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _globalConfig = require('../global-config');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function classNameVlidation(className, target) {
    if (_.isUndefined(className)) {
        if (_globalConfig.Global.vars.isProductionMode) {
            throw '[Morphi] Please provide "className" property for each Controller and Entity:\n\n      @Morphi.Controller({ className: \'MyExampleCtrl\'  })\n      class MyExampleCtrl {\n        ...\n      }\n\n      @Morphi.Entity({ className: \'MyExampleEntity\'  })\n      class MyExampleEntity {\n        ...\n      }\n    ';
        }
        className = target.name;
    }
    return className;
}