'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Morphi = exports.FormlyHorizontalWrapper = exports.RepeatTypeComponent = exports.Models = exports.Helpers = exports.MDC = exports.ModelDataConfig = undefined;

var _modelDataConfig = require('./crud/model-data-config');

Object.defineProperty(exports, 'ModelDataConfig', {
    enumerable: true,
    get: function get() {
        return _modelDataConfig.ModelDataConfig;
    }
});
Object.defineProperty(exports, 'MDC', {
    enumerable: true,
    get: function get() {
        return _modelDataConfig.MDC;
    }
});

var _helpers = require('./helpers');

Object.defineProperty(exports, 'Helpers', {
    enumerable: true,
    get: function get() {
        return _helpers.Helpers;
    }
});

var _models = require('./models');

Object.defineProperty(exports, 'Models', {
    enumerable: true,
    get: function get() {
        return _models.Models;
    }
});

var _formlyRepeatComponent = require('./crud/formly-repeat-component');

Object.defineProperty(exports, 'RepeatTypeComponent', {
    enumerable: true,
    get: function get() {
        return _formlyRepeatComponent.RepeatTypeComponent;
    }
});

var _formlyGroupWrapperComponent = require('./crud/formly-group-wrapper-component');

Object.defineProperty(exports, 'FormlyHorizontalWrapper', {
    enumerable: true,
    get: function get() {
        return _formlyGroupWrapperComponent.FormlyHorizontalWrapper;
    }
});

var _crud = require('./crud');

var crudMorph = _interopRequireWildcard(_crud);

var _decorators = require('./decorators');

var decoratorsMorphi = _interopRequireWildcard(_decorators);

var _framework = require('./framework');

var framework = _interopRequireWildcard(_framework);

var _realtime = require('./realtime');

var realtime = _interopRequireWildcard(_realtime);

var _globalConfig = require('./global-config');

var global = _interopRequireWildcard(_globalConfig);

var models = _interopRequireWildcard(_models);

var _symbols = require('./symbols');

var sym = _interopRequireWildcard(_symbols);

var helpers = _interopRequireWildcard(_helpers);

var _init = require('./init');

var initDeco = _interopRequireWildcard(_init);

var _isomorphicReplacements = require('./isomorphic-replacements');

var isom = _interopRequireWildcard(_isomorphicReplacements);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var Morphi = exports.Morphi = undefined;
(function (Morphi) {
    Morphi.IsNode = helpers.Helpers.isNode;
    Morphi.IsBrowser = helpers.Helpers.isBrowser;
    Morphi.Config = global.Global.vars;
    /**
     * Header name for model data config
     */
    Morphi.MDC_KEY = sym.SYMBOL.MDC_KEY;
    Morphi.Platform = Morphi.IsNode ? 'node' : 'browser';
    Morphi.Providers = initDeco.Providers;
    Morphi.Controller = framework.Controller;
    Morphi.Entity = framework.Entity;
    Morphi.init = framework.start;
    Morphi.SYMBOL = sym.SYMBOL;
    var Realtime = void 0;
    (function (Realtime) {
        var Browser = void 0;
        (function (Browser) {
            Browser.Class = realtime.RealtimeBrowser;
            Browser.SubscribeEntityChanges = realtime.RealtimeBrowser.SubscribeEntityChanges;
            Browser.SubscribeEntityPropertyChanges = realtime.RealtimeBrowser.SubscribeEntityPropertyChanges;
            Browser.UnsubscribeEverything = realtime.RealtimeBrowser.UnsubscribeEverything;
            Browser.UnsubscribeEntityChanges = realtime.RealtimeBrowser.UnsubscribeEntityChanges;
            Browser.UnsubscribeEntityPropertyChanges = realtime.RealtimeBrowser.UnsubscribeEntityPropertyChanges;
        })(Browser = Realtime.Browser || (Realtime.Browser = {}));
    })(Realtime = Morphi.Realtime || (Morphi.Realtime = {}));
    var CRUD = void 0;
    (function (CRUD) {
        CRUD.ModelDataConfig = crudMorph.ModelDataConfig;
        CRUD.Base = crudMorph.BaseCRUD;
    })(CRUD = Morphi.CRUD || (Morphi.CRUD = {}));
    var Formly = void 0;
    (function (Formly) {
        Formly.getFrom = crudMorph.getFromlyConfigFor;
        Formly.RegisterComponentForEntity = crudMorph.RegisterComponentTypeForEntity;
    })(Formly = Morphi.Formly || (Morphi.Formly = {}));
    var Base = void 0;
    (function (Base) {
        Base.Controller = framework.BASE_CONTROLLER;
        Base.Entity = framework.BASE_ENTITY;
    })(Base = Morphi.Base || (Morphi.Base = {}));
    var Http = void 0;
    (function (Http) {
        Http.GET = decoratorsMorphi.GET;
        Http.POST = decoratorsMorphi.POST;
        Http.PUT = decoratorsMorphi.PUT;
        Http.DELETE = decoratorsMorphi.DELETE;
        Http.PATCH = decoratorsMorphi.PATCH;
        Http.HEAD = decoratorsMorphi.HEAD;
        var Param = void 0;
        (function (Param) {
            Param.Query = decoratorsMorphi.Query;
            Param.Path = decoratorsMorphi.Path;
            Param.Body = decoratorsMorphi.Body;
            Param.Cookie = decoratorsMorphi.Cookie;
            Param.Header = decoratorsMorphi.Header;
        })(Param = Http.Param || (Http.Param = {}));
        var Resopnse = void 0;
        (function (Resopnse) {
            Resopnse.Success = models.Models.Rest.HttpResponse;
            Resopnse.Error = models.Models.Rest.HttpResponseError;
        })(Resopnse = Http.Resopnse || (Http.Resopnse = {}));
    })(Http = Morphi.Http || (Morphi.Http = {}));
    var Orm = void 0;
    (function (Orm) {
        Orm.Repository = isom.TypeormRepository;
    })(Orm = Morphi.Orm || (Morphi.Orm = {}));
})(Morphi || (exports.Morphi = Morphi = {}));