'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.initMethodBrowser = initMethodBrowser;

var _globalConfig = require('../global-config');

var _symbols = require('../symbols');

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _browser = require('ng2-rest/browser');

var _helpers = require('../helpers');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function initMethodBrowser(target, type, methodConfig, expressPath) {
    // console.log(`FRONTEND ${target.name} method on ${expressPath}`)
    target.prototype[methodConfig.methodName] = function () {
        // console.log('FRONTEND expressPath', expressPath)
        var productionMode = _globalConfig.Global.vars.productionMode;
        var uri = _globalConfig.Global.vars.url;
        if (!window[_symbols.SYMBOL.ENDPOINT_META_CONFIG]) window[_symbols.SYMBOL.ENDPOINT_META_CONFIG] = {};
        if (!window[_symbols.SYMBOL.ENDPOINT_META_CONFIG][uri.href]) window[_symbols.SYMBOL.ENDPOINT_META_CONFIG][uri.href] = {};
        var endpoints = window[_symbols.SYMBOL.ENDPOINT_META_CONFIG];
        var rest = void 0;
        if (!endpoints[uri.href][expressPath]) {
            rest = _browser.Resource.create(uri.href, expressPath, _symbols.SYMBOL.MAPPING_CONFIG_HEADER, _symbols.SYMBOL.CIRCURAL_OBJECTS_MAP_BODY);
            endpoints[uri.href][expressPath] = rest;
        } else {
            rest = endpoints[uri.href][expressPath];
        }
        var method = type.toLowerCase();
        var isWithBody = method === 'put' || method === 'post';
        var pathPrams = {};
        var queryParams = {};
        var item = {};

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        args.forEach(function (param, i) {
            var currentParam = void 0;
            //#region find param
            for (var pp in methodConfig.parameters) {
                var v = methodConfig.parameters[pp];
                if (v.index === i) {
                    currentParam = v;
                    break;
                }
            }
            //#endregion
            // debugger
            if (currentParam.paramType === 'Path') {
                pathPrams[currentParam.paramName] = param;
            }
            if (currentParam.paramType === 'Query') {
                if (currentParam.paramName) {
                    var mapping = _helpers.Helpers.Mapping.decode(param, !_globalConfig.Global.vars.isProductionMode);
                    if (mapping) {
                        rest.headers.set('' + _symbols.SYMBOL.MAPPING_CONFIG_HEADER_QUERY_PARAMS + currentParam.paramName, JSON.stringify(mapping));
                    }
                    queryParams[currentParam.paramName] = param;
                } else {
                    var _mapping = _helpers.Helpers.Mapping.decode(param, !_globalConfig.Global.vars.isProductionMode);
                    if (_mapping) {
                        rest.headers.set(_symbols.SYMBOL.MAPPING_CONFIG_HEADER_QUERY_PARAMS, JSON.stringify(_mapping));
                    }
                    queryParams = _.cloneDeep(param);
                }
            }
            if (currentParam.paramType === 'Header') {
                if (currentParam.paramName) {
                    if (currentParam.paramName === _symbols.SYMBOL.MDC_KEY) {
                        // parese MDC
                        rest.headers.set(currentParam.paramName, encodeURIComponent(JSON.stringify(param)));
                    } else {
                        rest.headers.set(currentParam.paramName, param);
                    }
                } else {
                    for (var header in param) {
                        rest.headers.set(header, param[header]);
                    }
                }
            }
            if (currentParam.paramType === 'Cookie') {
                _browser.Resource.Cookies.write(currentParam.paramName, param, currentParam.expireInSeconds);
            }
            if (currentParam.paramType === 'Body') {
                if (currentParam.paramName) {
                    var _mapping2 = _helpers.Helpers.Mapping.decode(param, !_globalConfig.Global.vars.isProductionMode);
                    if (_mapping2) {
                        rest.headers.set('' + _symbols.SYMBOL.MAPPING_CONFIG_HEADER_BODY_PARAMS + currentParam.paramName, JSON.stringify(_mapping2));
                    }
                    item[currentParam.paramName] = param;
                } else {
                    var _mapping3 = _helpers.Helpers.Mapping.decode(param, !_globalConfig.Global.vars.isProductionMode);
                    if (_mapping3) {
                        rest.headers.set(_symbols.SYMBOL.MAPPING_CONFIG_HEADER_BODY_PARAMS, JSON.stringify(_mapping3));
                    }
                    item = param;
                }
            }
        });
        // debugger;
        if ((typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object') {
            var circuralFromItem = [];
            item = _helpers.Helpers.JSON.parse(_helpers.Helpers.JSON.stringify(item, void 0, void 0, function (circs) {
                circuralFromItem = circs;
            }));
            rest.headers.set(_symbols.SYMBOL.CIRCURAL_OBJECTS_MAP_BODY, JSON.stringify(circuralFromItem));
        }
        if ((typeof queryParams === 'undefined' ? 'undefined' : _typeof(queryParams)) === 'object') {
            var circuralFromQueryParams = [];
            queryParams = _helpers.Helpers.JSON.parse(_helpers.Helpers.JSON.stringify(queryParams, void 0, void 0, function (circs) {
                circuralFromQueryParams = circs;
            }));
            rest.headers.set(_symbols.SYMBOL.CIRCURAL_OBJECTS_MAP_QUERY_PARAM, JSON.stringify(circuralFromQueryParams));
        }
        return {
            received: isWithBody ? rest.model(pathPrams)[method](item, [queryParams]) : rest.model(pathPrams)[method]([queryParams])
        };
    };
}