import { ModelDataConfig } from './model-data-config';
import { Models } from '../models';
import { Repository, Connection } from 'typeorm';
export declare abstract class BaseCRUD<T> {
    connection: Connection;
    get repository(): Repository<T>;
    private repo;
    entity: any;
    constructor();
    private init;
    bufforedChanges(id: number, property: string, alreadyLength?: number, config?: ModelDataConfig): Models.Response<string | any[]>;
    getAll(config?: ModelDataConfig): Models.Response<T[]>;
    getBy(id: number, config?: ModelDataConfig): Models.Response<T>;
    updateById(id: number, item: T, config?: ModelDataConfig): Models.Response<T>;
    deleteById(id: number, config?: ModelDataConfig): Models.Response<T>;
    create(item: T, config?: ModelDataConfig): Models.Response<T>;
}
