"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
//#endregion
var init_method_1 = require("../init-method");
var typescript_class_helpers_1 = require("typescript-class-helpers");
exports.CLASS = typescript_class_helpers_1.CLASS;
var typescript_class_helpers_2 = require("typescript-class-helpers");
var _ = require("lodash");
var global_config_1 = require("../global-config");
var symbols_1 = require("../symbols");
var helpers_1 = require("../helpers");
var activate_base_crud_1 = require("../crud/activate-base-crud");
var typeorm_1 = require("typeorm");
exports.Connection = typeorm_1.Connection;
function __ENDPOINT(baseEntity) {
    if (baseEntity)
        global_config_1.Global.vars.__core_controllers.push(baseEntity);
    return ENDPOINT();
}
exports.__ENDPOINT = __ENDPOINT;
function ENDPOINT(options) {
    return function (target) {
        var _a = options ? options : {}, path = _a.path, auth = _a.auth, _b = _a.realtime, realtime = _b === void 0 ? false : _b, entity = _a.entity, additionalEntities = _a.additionalEntities;
        target.prototype[symbols_1.SYMBOL.IS_ENPOINT_REALTIME] = realtime;
        var initFN = (function (target, path, auth) {
            return function () {
                // debugger
                // console.log(`INITING ${target.name} , parent ${target['__proto__'].name} `)
                activate_base_crud_1.activateBaseCrud(target, entity, additionalEntities);
                //#region  access decorator config
                var configs = typescript_class_helpers_2.CLASS.getConfig(target);
                // console.log(`Class config for ${CLASS.getName(target)}`, configs)
                var classConfig = configs[0];
                classConfig.path = path;
                var parentscalculatedPath = _
                    .slice(configs, 1)
                    .reverse()
                    .map(function (bc) {
                    if (helpers_1.Helpers.isGoodPath(bc.path)) {
                        return bc.path;
                    }
                    return typescript_class_helpers_2.CLASS.getName(bc.classReference);
                }).join('/');
                if (helpers_1.Helpers.isGoodPath(path)) {
                    classConfig.calculatedPath = path;
                }
                else {
                    classConfig.calculatedPath = ("/" + parentscalculatedPath + "/" + typescript_class_helpers_2.CLASS.getName(target))
                        .replace(/\/\//g, '/');
                }
                // console.log(`${classConfig.calculatedPath}, target ${target.name}`)
                var checkAuthFn = (auth && typeof auth === 'function');
                _.slice(configs, 1).forEach(function (bc) {
                    var alreadyIs = classConfig.methods;
                    var toMerge = _.cloneDeep(bc.methods);
                    for (var key in toMerge) {
                        if (toMerge.hasOwnProperty(key) && !alreadyIs[key]) {
                            var element = toMerge[key];
                            alreadyIs[key] = element;
                        }
                    }
                });
                //#endregion
                Object.keys(classConfig.methods).forEach(function (methodName) {
                    var methodConfig = classConfig.methods[methodName];
                    var type = methodConfig.type;
                    var expressPath = helpers_1.Helpers.getExpressPath(classConfig, methodConfig);
                    // console.log('initfn expressPath', expressPath)
                    if (helpers_1.Helpers.isNode) {
                        //#region @backend
                        if (checkAuthFn) {
                            methodConfig.requestHandler = auth(methodConfig.descriptor.value);
                        }
                        var _a = init_method_1.initMethodNodejs(type, methodConfig, classConfig, expressPath), routePath = _a.routePath, method = _a.method;
                        global_config_1.Global.vars.activeRoutes.push({
                            routePath: routePath,
                            method: method
                        });
                        //#endregion
                    }
                    if (helpers_1.Helpers.isBrowser) {
                        init_method_1.initMethodBrowser(target, type, methodConfig, expressPath);
                    }
                });
            };
        })(target, path, auth);
        target.prototype[symbols_1.SYMBOL.CLASS_DECORATOR_CONTEXT] = { initFN: initFN, target: target };
        global_config_1.Global.vars.initFunc.push({ initFN: initFN, target: target });
    };
}
exports.ENDPOINT = ENDPOINT;
// TODO allowed hosts in progress
//# sourceMappingURL=decorators-endpoint-class.js.map