"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var typeorm_1 = require("typeorm");
var express = require("express");
var typeorm_2 = require("typeorm");
exports.Connection = typeorm_2.Connection;
var helpers_1 = require("../helpers");
//#endregion
var _ = require("lodash");
var global_config_1 = require("../global-config");
var init_1 = require("../init");
function start(options) {
    var _this = this;
    //#region @backend
    return new Promise(function (resolve, reject) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
        var _a, host, _b, controllers, _c, entities, 
        //#region @backend
        config, InitDataPriority, _d, publicAssets, _e, testMode, con, connectionExists, error_1, connections, connection, app, ctrls, promises;
        return tslib_1.__generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    _a = options, host = _a.host, _b = _a.controllers, controllers = _b === void 0 ? [] : _b, _c = _a.entities, entities = _c === void 0 ? [] : _c, config = _a.config, InitDataPriority = _a.InitDataPriority, _d = _a.publicAssets, publicAssets = _d === void 0 ? [] : _d, _e = _a.testMode, testMode = _e === void 0 ? false : _e;
                    // console.log(options)
                    //#region @backend
                    if (!config) {
                        config = {};
                        console.error("\n\n        Missing config for backend:\n\n\n        Morphi.init({\n          ...\n          config: <YOUR DB CONFIG HERE>\n          ...\n        })\n\n      ");
                    }
                    config['entities'] = entities;
                    _f.label = 1;
                case 1:
                    _f.trys.push([1, 5, , 6]);
                    return [4 /*yield*/, typeorm_1.getConnection()];
                case 2:
                    con = _f.sent();
                    connectionExists = !!(con);
                    if (!connectionExists) return [3 /*break*/, 4];
                    console.log('Connection exists');
                    return [4 /*yield*/, con.close()];
                case 3:
                    _f.sent();
                    _f.label = 4;
                case 4: return [3 /*break*/, 6];
                case 5:
                    error_1 = _f.sent();
                    return [3 /*break*/, 6];
                case 6: return [4 /*yield*/, typeorm_1.createConnections([config])];
                case 7:
                    connections = _f.sent();
                    connection = connections[0];
                    // console.log('init connection', connection)
                    //#endregion
                    init_1.init({
                        host: host,
                        controllers: controllers,
                        entities: entities,
                        //#region @backend
                        connection: connection,
                        testMode: testMode,
                    });
                    app = global_config_1.Global.vars.app;
                    publicAssets.forEach(function (asset) {
                        app.use(asset.path, express.static(asset.location));
                    });
                    ctrls = controllers;
                    if (InitDataPriority) {
                        ctrls = tslib_1.__spreadArrays((InitDataPriority ? InitDataPriority : []), (ctrls.filter(function (f) { return !InitDataPriority.includes(f); })));
                    }
                    ctrls = ctrls.filter(function (ctrl) { return !['BASE_CONTROLLER', 'BaseCRUD'].includes(ctrl.name); });
                    promises = [];
                    // console.log('ctrls', ctrls)
                    ctrls.forEach(function (ctrl) {
                        ctrl = helpers_1.Helpers.getSingleton(ctrl);
                        if (ctrl && _.isFunction(ctrl.initExampleDbData)) {
                            promises.push((ctrl.initExampleDbData()));
                        }
                    });
                    return [4 /*yield*/, Promise.all(promises)];
                case 8:
                    _f.sent();
                    //#endregion
                    //#region @backend
                    resolve(connection);
                    return [2 /*return*/];
            }
        });
    }); });
    //#endregion
}
exports.start = start;
//# sourceMappingURL=framework-start.js.map