"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var helpers_1 = require("./helpers");
//#region @backend
var path = require("path");
var fse = require("fs-extra");
//#endregion
var Global = /** @class */ (function () {
    function Global() {
        this._isProductionModeAlreadySet = false;
        this._isProductionMode = false;
        this.productionMode = false;
        this.controllers = [];
        this.__core_controllers = [];
        this.entities = [];
        this.__core_entities = [];
        this.initFunc = [];
        this.allowedHosts = [];
        //#region @backend
        this.activeRoutes = [];
    }
    Object.defineProperty(Global.prototype, "socketNamespace", {
        get: function () {
            var self = this;
            return {
                set FE(v) {
                    if (!helpers_1.Helpers.isBrowser) {
                        //#region @backend
                        console.trace("CANNOT USE frontend socket on backend side.");
                        process.exit(1);
                        //#endregion
                    }
                    self.socketFrontEnd = v;
                },
                get FE() {
                    return self.socketFrontEnd;
                },
                set FE_REALTIME(v) {
                    if (!helpers_1.Helpers.isBrowser) {
                        //#region @backend
                        console.trace("CANNOT USE frontend socket on backend side.");
                        process.exit(1);
                        //#endregion
                    }
                    self.socketFrontEndRealtime = v;
                },
                get FE_REALTIME() {
                    return self.socketFrontEndRealtime;
                },
                //#region @backend
                set BE(v) {
                    self.socketNamespaceBE = v;
                },
                get BE() {
                    return self.socketNamespaceBE;
                },
                set BE_REALTIME(v) {
                    self.socketNamespaceBERealtime = v;
                },
                get BE_REALTIME() {
                    return self.socketNamespaceBERealtime;
                }
                //#endregion
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Global.prototype, "isProductionMode", {
        get: function () {
            return this._isProductionMode;
        },
        set: function (v) {
            if (!this._isProductionModeAlreadySet) {
                this._isProductionModeAlreadySet = true;
            }
            else {
                throw "[Morphi] production mode already set";
            }
            this._isProductionMode = v;
        },
        enumerable: true,
        configurable: true
    });
    Global.prototype.writeActiveRoutes = function () {
        var routes = this.activeRoutes.map(function (_a) {
            var method = _a.method, routePath = _a.routePath;
            return method.toUpperCase() + ":    " + routePath;
        });
        fse.writeJSONSync(path.join(process.cwd(), 'tmp-routes.json'), routes, {
            spaces: 2,
            encoding: 'utf8'
        });
    };
    Global.prototype.get = function (key) {
        //#region @backend
        if (helpers_1.Helpers.isNode) {
            return global[key];
        }
        //#endregion
        if (helpers_1.Helpers.isBrowser) {
            return window[key];
        }
    };
    Global.prototype.set = function (value, key) {
        //#region @backend
        if (helpers_1.Helpers.isNode) {
            global[key] = value;
        }
        //#endregion
        if (helpers_1.Helpers.isBrowser) {
            window[key] = value;
        }
    };
    //#endregion
    Global.vars = new Global();
    return Global;
}());
exports.Global = Global;
//# sourceMappingURL=global-config.js.map