/// <reference types="node" />
import * as child from 'child_process';
import { Helpers as HelpersNg2Rest } from 'ng2-rest';
import { Models } from './models';
import { Response as ExpressResponse, Request as ExpressRequest } from 'express';
export declare class Helpers extends HelpersNg2Rest {
    static get System(): {
        readonly Operations: {
            tryRemoveDir(dirpath: any): void;
            tryCopyFrom(source: any, destination: any, options?: {}): void;
        };
    };
    static isGoodPath(p: string): boolean;
    static isRealtimeEndpoint(target: Function): any;
    static hasParentClassWithName(target: Function, name: string, targets?: any[]): boolean;
    static compilationWrapper(fn: () => void, taskName?: string, executionType?: 'Compilation' | 'Code execution'): Promise<void>;
    static runSyncOrAsync(fn: Function): any;
    static tryTransformParam(param: any): any;
    static getExpressPath(c: Models.Rest.ClassConfig, pathOrClassConfig: Models.Rest.MethodConfig | string): string;
    static defaultType(value: any): {};
    static getSingleton<T = Object>(target: Function): T;
    static getSingletons<T = Object>(target: Function): T[];
    static parseJSONwithStringJSONs(object: Object, waring?: boolean): Object;
    static getResponseValue<T>(response: Models.Response<T>, req: ExpressRequest, res: ExpressResponse): Promise<Models.SyncResponse<T>>;
    static MorphiGlobalDependencies: Models.GlobalDependencies;
    static checkEnvironment(globalDependencies?: Models.GlobalDependencies): void;
    static isPlainFileOrFolder(filePath: any): boolean;
    static log(proc: child.ChildProcess): void;
    static createLink(target: string, link: string): string;
    static getRecrusiveFilesFrom(dir: any): string[];
}
