export { config } from './build/config';
export { FILE_NAME_ISOMORPHIC_PACKAGES } from './build/packages-recognition';
export { CodeCut, BrowserCodeCut, TsUsage, IncrementalBuildProcess, PackagesRecognition, BroswerCompilation, OutFolder, BackendCompilation } from './build';
export { ModelDataConfig, MDC } from './crud/model-data-config';
export { Helpers } from './helpers';
export { Models } from './models';
export { RepeatTypeComponent } from './crud/formly-repeat-component';
export { FormlyHorizontalWrapper } from './crud/formly-group-wrapper-component';
import * as crudMorph from './crud';
import * as decoratorsMorphi from './decorators';
import * as framework from './framework';
import * as realtime from './realtime';
import * as global from './global-config';
import * as models from './models';
import * as sym from './symbols';
import * as helpers from './helpers';
import * as isom from './isomorphic-replacements';
import { generate } from 'password-hash';
import * as tsorm from 'typeorm';
export * from './build-tool';
export declare namespace Morphi {
    const IsNode: boolean;
    const IsBrowser: boolean;
    const Config: global.Global;
    /**
     * Header name for model data config
     */
    const MDC_KEY: string;
    const Platform: string;
    const Providers: Function[];
    export import Response = models.Models.Response;
    export import Controller = framework.Controller;
    export import Entity = framework.Entity;
    export import Repository = framework.Repository;
    const getResponseValue: typeof helpers.Helpers.getResponseValue;
    export import init = framework.start;
    export import SYMBOL = sym.SYMBOL;
    namespace Realtime {
        namespace Browser {
            export import Class = realtime.RealtimeBrowser;
            const SubscribeEntityChanges: typeof Class.SubscribeEntityChanges;
            const SubscribeEntityPropertyChanges: typeof Class.SubscribeEntityPropertyChanges;
            const UnsubscribeEverything: typeof Class.UnsubscribeEverything;
            const UnsubscribeEntityChanges: typeof Class.UnsubscribeEntityChanges;
            const UnsubscribeEntityPropertyChanges: typeof Class.UnsubscribeEntityPropertyChanges;
        }
        namespace Server {
            export import Class = realtime.RealtimeNodejs;
            const TrigggerEntityChanges: typeof Class.TrigggerEntityChanges;
            const TrigggerEntityPropertyChanges: typeof Class.TrigggerEntityPropertyChanges;
        }
    }
    namespace CRUD {
        export import ModelDataConfig = crudMorph.ModelDataConfig;
        export import Base = crudMorph.BaseCRUD;
    }
    namespace Formly {
        export import getFrom = crudMorph.getFromlyConfigFor;
        export import RegisterComponentForEntity = crudMorph.RegisterComponentTypeForEntity;
    }
    namespace Base {
        export import Controller = framework.BASE_CONTROLLER;
        export import Entity = framework.BASE_ENTITY;
        export import Repository = framework.BASE_REPOSITORY;
    }
    namespace Http {
        export import GET = decoratorsMorphi.GET;
        export import POST = decoratorsMorphi.POST;
        export import PUT = decoratorsMorphi.PUT;
        export import DELETE = decoratorsMorphi.DELETE;
        export import PATCH = decoratorsMorphi.PATCH;
        export import HEAD = decoratorsMorphi.HEAD;
        namespace Param {
            export import Query = decoratorsMorphi.Query;
            export import Path = decoratorsMorphi.Path;
            export import Body = decoratorsMorphi.Body;
            export import Cookie = decoratorsMorphi.Cookie;
            export import Header = decoratorsMorphi.Header;
        }
        namespace Resopnse {
            export import Success = models.Models.Rest.HttpResponse;
            export import Error = models.Models.Rest.HttpResponseError;
        }
    }
    namespace Auth {
        namespace Password {
            namespace Hash {
                const Generate: typeof generate;
            }
        }
    }
    namespace Orm {
        export import Repository = isom.TypeormRepository;
        export import getConnection = tsorm.getConnection;
        export import Errors = models.Models.Errors;
        export import InjectConnection = decoratorsMorphi.OrmConnection;
        export import Connection = tsorm.Connection;
        export import CreateConnection = tsorm.createConnection;
        export import TableNameFrom = framework.tableNameFrom;
        export import RepositoryFrom = framework.repositoryFrom;
        namespace Tree {
            export import Children = tsorm.TreeChildren;
            export import Parent = tsorm.TreeParent;
        }
        namespace Column {
            export import Generated = tsorm.PrimaryGeneratedColumn;
            export import Primary = tsorm.PrimaryColumn;
            export import CreateDate = tsorm.CreateDateColumn;
            export import Custom = tsorm.Column;
        }
        namespace Join {
            export import Table = tsorm.JoinTable;
            export import Column = tsorm.JoinColumn;
        }
        namespace Relation {
            export import OneToMany = tsorm.OneToMany;
            export import OneToOne = tsorm.OneToOne;
            export import ManyToMany = tsorm.ManyToMany;
            export import ManyToOne = tsorm.ManyToOne;
        }
    }
}
