"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
//#region @backend
var config_1 = require("./build/config");
exports.config = config_1.config;
var packages_recognition_1 = require("./build/packages-recognition");
exports.FILE_NAME_ISOMORPHIC_PACKAGES = packages_recognition_1.FILE_NAME_ISOMORPHIC_PACKAGES;
var build_1 = require("./build");
exports.CodeCut = build_1.CodeCut;
exports.BrowserCodeCut = build_1.BrowserCodeCut;
exports.IncrementalBuildProcess = build_1.IncrementalBuildProcess;
exports.PackagesRecognition = build_1.PackagesRecognition;
exports.BroswerCompilation = build_1.BroswerCompilation;
exports.BackendCompilation = build_1.BackendCompilation;
//#endregion
var model_data_config_1 = require("./crud/model-data-config");
exports.ModelDataConfig = model_data_config_1.ModelDataConfig;
exports.MDC = model_data_config_1.MDC;
var helpers_1 = require("./helpers");
exports.Helpers = helpers_1.Helpers;
var models_1 = require("./models");
exports.Models = models_1.Models;
var formly_repeat_component_1 = require("./crud/formly-repeat-component");
exports.RepeatTypeComponent = formly_repeat_component_1.RepeatTypeComponent;
var formly_group_wrapper_component_1 = require("./crud/formly-group-wrapper-component");
exports.FormlyHorizontalWrapper = formly_group_wrapper_component_1.FormlyHorizontalWrapper;
var crudMorph = require("./crud");
var decoratorsMorphi = require("./decorators");
var framework = require("./framework");
var realtime = require("./realtime");
var global = require("./global-config");
var models = require("./models");
var sym = require("./symbols");
var helpers = require("./helpers");
var initDeco = require("./init");
var isom = require("./isomorphic-replacements");
var password_hash_1 = require("password-hash");
var tsorm = require("typeorm");
tslib_1.__exportStar(require("./build-tool"), exports);
//#endregion
var Morphi;
(function (Morphi) {
    Morphi.IsNode = helpers.Helpers.isNode;
    Morphi.IsBrowser = helpers.Helpers.isBrowser;
    Morphi.Config = global.Global.vars;
    /**
     * Header name for model data config
     */
    Morphi.MDC_KEY = sym.SYMBOL.MDC_KEY;
    Morphi.Platform = Morphi.IsNode ? 'node' : 'browser';
    Morphi.Providers = initDeco.Providers;
    Morphi.Controller = framework.Controller;
    Morphi.Entity = framework.Entity;
    //#region @backend
    Morphi.Repository = framework.Repository;
    Morphi.getResponseValue = helpers.Helpers.getResponseValue;
    // export const authenticate = pass.authenticate
    //#endregion
    Morphi.init = framework.start;
    Morphi.SYMBOL = sym.SYMBOL;
    var Realtime;
    (function (Realtime) {
        var Browser;
        (function (Browser) {
            Browser.Class = realtime.RealtimeBrowser;
            Browser.SubscribeEntityChanges = realtime.RealtimeBrowser.SubscribeEntityChanges;
            Browser.SubscribeEntityPropertyChanges = realtime.RealtimeBrowser.SubscribeEntityPropertyChanges;
            Browser.UnsubscribeEverything = realtime.RealtimeBrowser.UnsubscribeEverything;
            Browser.UnsubscribeEntityChanges = realtime.RealtimeBrowser.UnsubscribeEntityChanges;
            Browser.UnsubscribeEntityPropertyChanges = realtime.RealtimeBrowser.UnsubscribeEntityPropertyChanges;
        })(Browser = Realtime.Browser || (Realtime.Browser = {}));
        //#region @backend
        var Server;
        (function (Server) {
            Server.Class = realtime.RealtimeNodejs;
            Server.TrigggerEntityChanges = realtime.RealtimeNodejs.TrigggerEntityChanges;
            Server.TrigggerEntityPropertyChanges = realtime.RealtimeNodejs.TrigggerEntityPropertyChanges;
        })(Server = Realtime.Server || (Realtime.Server = {}));
        //#endregion
    })(Realtime = Morphi.Realtime || (Morphi.Realtime = {}));
    var CRUD;
    (function (CRUD) {
        CRUD.ModelDataConfig = crudMorph.ModelDataConfig;
        CRUD.Base = crudMorph.BaseCRUD;
    })(CRUD = Morphi.CRUD || (Morphi.CRUD = {}));
    var Formly;
    (function (Formly) {
        Formly.getFrom = crudMorph.getFromlyConfigFor;
        Formly.RegisterComponentForEntity = crudMorph.RegisterComponentTypeForEntity;
    })(Formly = Morphi.Formly || (Morphi.Formly = {}));
    var Base;
    (function (Base) {
        Base.Controller = framework.BASE_CONTROLLER;
        Base.Entity = framework.BASE_ENTITY;
        //#region @backend
        Base.Repository = framework.BASE_REPOSITORY;
        //#endregion
    })(Base = Morphi.Base || (Morphi.Base = {}));
    var Http;
    (function (Http) {
        Http.GET = decoratorsMorphi.GET;
        Http.POST = decoratorsMorphi.POST;
        Http.PUT = decoratorsMorphi.PUT;
        Http.DELETE = decoratorsMorphi.DELETE;
        Http.PATCH = decoratorsMorphi.PATCH;
        Http.HEAD = decoratorsMorphi.HEAD;
        var Param;
        (function (Param) {
            Param.Query = decoratorsMorphi.Query;
            Param.Path = decoratorsMorphi.Path;
            Param.Body = decoratorsMorphi.Body;
            Param.Cookie = decoratorsMorphi.Cookie;
            Param.Header = decoratorsMorphi.Header;
        })(Param = Http.Param || (Http.Param = {}));
        var Resopnse;
        (function (Resopnse) {
            Resopnse.Success = models.Models.Rest.HttpResponse;
            Resopnse.Error = models.Models.Rest.HttpResponseError;
        })(Resopnse = Http.Resopnse || (Http.Resopnse = {}));
    })(Http = Morphi.Http || (Morphi.Http = {}));
    var Auth;
    (function (Auth) {
        //#region @backend
        var Password;
        (function (Password) {
            var Hash;
            (function (Hash) {
                Hash.Generate = password_hash_1.generate;
            })(Hash = Password.Hash || (Password.Hash = {}));
        })(Password = Auth.Password || (Auth.Password = {}));
        //#endregion
    })(Auth = Morphi.Auth || (Morphi.Auth = {}));
    var Orm;
    (function (Orm) {
        Orm.Repository = isom.TypeormRepository;
        //#region @backend
        Orm.getConnection = tsorm.getConnection;
        Orm.Errors = models.Models.Errors;
        Orm.InjectConnection = decoratorsMorphi.OrmConnection;
        Orm.Connection = tsorm.Connection;
        Orm.CreateConnection = tsorm.createConnection;
        Orm.TableNameFrom = framework.tableNameFrom;
        Orm.RepositoryFrom = framework.repositoryFrom;
        var Tree;
        (function (Tree) {
            Tree.Children = tsorm.TreeChildren;
            Tree.Parent = tsorm.TreeParent;
        })(Tree = Orm.Tree || (Orm.Tree = {}));
        var Column;
        (function (Column) {
            Column.Generated = tsorm.PrimaryGeneratedColumn;
            Column.Primary = tsorm.PrimaryColumn;
            Column.CreateDate = tsorm.CreateDateColumn;
            Column.Custom = tsorm.Column;
        })(Column = Orm.Column || (Orm.Column = {}));
        var Join;
        (function (Join) {
            Join.Table = tsorm.JoinTable;
            Join.Column = tsorm.JoinColumn;
        })(Join = Orm.Join || (Orm.Join = {}));
        var Relation;
        (function (Relation) {
            Relation.OneToMany = tsorm.OneToMany;
            Relation.OneToOne = tsorm.OneToOne;
            Relation.ManyToMany = tsorm.ManyToMany;
            Relation.ManyToOne = tsorm.ManyToOne;
        })(Relation = Orm.Relation || (Orm.Relation = {}));
        //#endregion
    })(Orm = Morphi.Orm || (Morphi.Orm = {}));
})(Morphi = exports.Morphi || (exports.Morphi = {}));
//# sourceMappingURL=index.js.map