"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ng2_rest_1 = require("ng2-rest");
require("rxjs/add/operator/map");
var typescript_class_helpers_1 = require("typescript-class-helpers");
var Models;
(function (Models) {
    Models.Rest = ng2_rest_1.Models;
    var Errors = /** @class */ (function () {
        function Errors(message, code) {
            var _this = this;
            if (code === void 0) { code = 400; }
            this.message = message;
            this.code = code;
            this.toString = function () {
                return _this.message;
            };
        }
        Errors.create = function (message, code) {
            if (code === void 0) { code = 400; }
            return new Errors(message, code);
        };
        Errors.entityNotFound = function (entity) {
            return Errors.create("Entity " + typescript_class_helpers_1.CLASS.getName(entity) + " not found");
        };
        Errors.custom = function (message, code) {
            if (code === void 0) { code = 400; }
            return Errors.create(message, code);
        };
        return Errors;
    }());
    Models.Errors = Errors;
    //#endregion
})(Models = exports.Models || (exports.Models = {}));
//# sourceMappingURL=models.js.map